//	Vamos Automotive Simulator
//  Copyright (C) 2003 Sam Varner
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <vamos/geometry/Linear_Interpolator.h>

#include <iostream>
#include <vector>

using Vamos_Geometry::Two_Point;

int main ()
{
  std::vector <Two_Point> points;
  points.push_back (Two_Point (0.0, 0.0));
  points.push_back (Two_Point (200.0, 100.0));
  points.push_back (Two_Point (200.0, 200.0));

  Vamos_Geometry::Linear_Interpolator curve (points);

  curve.clear ();
  curve.load (Two_Point (0.0, 0.0));
  curve.load (Two_Point (1.0, 20.0));
  curve.load (Two_Point (2.0, 15.0));
  curve.load (Two_Point (5.0, 10.0));
  curve.load (Two_Point (5.5, 15.0));
  curve.load (Two_Point (6.0, 20.0));
  curve.load (Two_Point (7.0, 0.0));
  curve.load (Two_Point (10.0, 20.0));

  curve.scale (2.0);

  for (double x = 0.0; x < 20.0; x += 0.1)
	{
	  double y = curve.interpolate (x);
	  std::cout << x << ' ' << y << std::endl;
	  Two_Point norm = curve.normal (x);
	  std::cout << x + norm.x << ' ' << y + norm.y << std::endl;
	}

  return 0;
}
